DCMTK: DPMParametricMapIOD Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Private Member Functions | Private Attributes | List of all members
DPMParametricMapIOD Class Reference

Class for managing the Parametric Map IOD attributes. More...

Inheritance diagram for DPMParametricMapIOD:

## Classes
class | Frames
| Inner class that offers typed interface to bulk data. More...
class | GetPixelDataVisitor

## Public Types
typedef OFvariant< OFCondition, Frames< Uint16 >, Frames< Sint16 >, Frames< Float32 >, Frames< Float64 > > | FramesType
| Frames can contain Uint16, Sint16, Float32 or Float64 data, or nothing at all (in that case OFCondition denotes a corresponding error)
Public Types inherited from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 >, IODFloatingPointImagePixelModule, IODDoubleFloatingPointImagePixelModule >
typedef DcmIODImage | IODImage
| typedef for old compilers that do not define the type 'DcmIODImage' in derived classes.
typedef IODImagePixelVariant< OFVARIADIC_TEMPLATE_PARAMETER_PACK(T)> | IODImagePixelModuleType
| A good comment would be nice, but I have nothing in mind.

## Public Member Functions
virtual | ~DPMParametricMapIOD ()
| Virtual Destructor, frees memory.
virtual OFCondition | setRecognizableVisualFeatures (const DPMTypes::RecognizableVisibleFeatures yesOrNo)
| Indicates whether or not the image contains sufficiently recognizable visual features to allow the image or a reconstruction from a set of images to identify the patient.
virtual OFCondition | addForAllFrames (const FGBase &group)
| Add a functional group for all frames.
virtual OFCondition | read (DcmItem &dataset)
| Read Parametric Map attributes (all those handled by this class) from given item.
virtual OFCondition | write (DcmItem &dataset)
| Write current Parametric Map's attributes to DICOM dataset.
virtual DPMTypes::RecognizableVisibleFeatures | getRecognizableVisualFeatures ()
| Get Recognizable Visual Features.
virtual DPMTypes::ContentQualification | getContentQualification ()
| Get Content Qualification.
virtual OFCondition | getRows (Uint16 &rows)
| Get number of rows.
virtual OFCondition | getColumns (Uint16 &cols)
| Get number of cols.
virtual OFBool | check ()
| Perform some basic checking.
size_t | getNumberOfFrames () const
| Get number of frames, based on the number of items in the shared functional functional groups sequence (i.e. the attribute Number of Frames) is not trusted after reading.
FramesType | getFrames ()
| Get access to frame data.
Public Member Functions inherited from DPMParametricMapBase
virtual | ~DPMParametricMapBase ()
| Virtual Destructor.
virtual OFCondition | saveFile (const OFString &filename, const E_TransferSyntax writeXfer=EXS_LittleEndianExplicit)
| Save current object to given filename.
OFCondition | writeDataset (DcmItem &dataset)
| Write current object to given item.
virtual FGInterface & | getFunctionalGroups ()
| Get access to functional groups.
virtual IODPatientModule & | getIODPatientModule ()
| Get Patient Module.
virtual IODGeneralStudyModule & | getIODGeneralStudyModule ()
| Get General Study Module.
virtual IODPatientStudyModule & | getIODPatientStudyModule ()
| Get Patient Study Module.
virtual IODGeneralSeriesModule & | getIODGeneralSeriesModule ()
| Get General Series Module.
virtual DPMParametricMapSeriesModule & | getDPMParametricMapSeriesModule ()
| Get Parametric Map Series Module.
virtual IODGeneralEquipmentModule & | getIODGeneralEquipmentModule ()
| Get General Equipment Module.
virtual IODEnhGeneralEquipmentModule & | getIODEnhGeneralEquipmentModule ()
| Get Enhanced General Equipment Module.
virtual IODGeneralImageModule & | getIODGeneralImageModule ()
| Get General Image Module.
virtual DPMParametricMapImageModule & | getDPMParametricMapImageModule ()
| Get Parametric Map Image Module.
virtual IODMultiFrameFGModule & | getIODMultiFrameFGModule ()
| Get Multi-frame Functional Groups Module.
virtual IODMultiframeDimensionModule & | getIODMultiframeDimensionModule ()
| Get Multi-frame Dimension Module.
virtual IODAcquisitionContextModule & | getIODAcquisitionContextModule ()
| Get Acquisition Context Module.
virtual IODCommonInstanceReferenceModule & | getIODCommonInstanceReferenceModule ()
| Get Common Instance Reference Module.
virtual IODSOPCommonModule & | getIODSOPCommonModule ()
| Get SOP Common Module.
Public Member Functions inherited from DcmIODImage< IODImagePixelModule< Uint16 >, IODImagePixelModule< Sint16 >, IODFloatingPointImagePixelModule, IODDoubleFloatingPointImagePixelModule >
| DcmIODImage ()
| Constructor, creates new DcmIODImage instance with integer-based pixel data.
| DcmIODImage (OFin_place_type_t(ImagePixel))
| Constructor, constructs new DcmIODImage instance with integer, float or double based Image Pixel Module (i.
virtual | ~DcmIODImage ()
| Virtual Destructor.
IODGeneralImageModule & | getGeneralImage ()
| Get General Image Module.
IODImagePixelModuleType & | getImagePixel ()
| Get Image Pixel Module (variant)
Public Member Functions inherited from DcmIODCommon
| DcmIODCommon ()
| Constructor.
| DcmIODCommon (const DcmIODCommon &rhs)
| Copy Constructor.
OFshared_ptr< IODRules > | getRules ()
| Get rules handled by this IOD.
OFshared_ptr< DcmItem > | getData ()
| Get item managed by this IOD.
IODPatientModule & | getPatient ()
| Get Patient Module.
IODPatientStudyModule & | getPatientStudy ()
| Get Patient Study Module.
IODGeneralStudyModule & | getStudy ()
| Get General Study Module.
IODGeneralEquipmentModule & | getEquipment ()
| Get General Equipment Module.
IODGeneralSeriesModule & | getSeries ()
| Get Series Module.
IODFoRModule & | getFrameOfReference ()
| Get Frame of Reference Module.
IODSOPCommonModule & | getSOPCommon ()
| Get SOP Common Module.
IODCommonInstanceReferenceModule & | getCommonInstanceReference ()
| Get Common Instance Reference Module.
virtual | ~DcmIODCommon ()
| Destructor.
virtual void | createNewStudy (const OFBool clearEquipment=OFTrue)
| Create new study.
virtual void | createNewSeries (const OFBool clearFoR=OFTrue)
| Create a new series.
virtual void | createNewSOPInstance ()
| Create a new SOP instance.
virtual void | ensureInstanceUIDs (const OFBool correctInvalid=OFFalse)
| Make sure that the IOD contains a SOP Instance, Series Instance and Study Instance UID.
virtual OFCondition | importHierarchy (DcmItem &dataset, const OFBool readPatient, const OFBool readStudy, const OFBool readFoR=OFFalse, const OFBool readSeries=OFFalse, const OFBool takeOverCharset=OFTrue)
| Import common module attributes from dataset but only read Patient, Study, Series and/or Frame of Reference level portions.
virtual OFCondition | importHierarchy (const OFString &filename, const OFBool readPatient, const OFBool readStudy, const OFBool readFoR=OFFalse, const OFBool readSeries=OFFalse, const OFBool takeOverCharset=OFTrue)
| CAUTION: Parameter order (readFoR and readSeries) changed compared to the old import() function.
virtual void | setValueCheckOnWrite (const OFBool checkValue)
| Set whether attribute values should be checked on writing, i.e.
virtual OFBool | getValueCheckOnWrite () const
| Get whether attribute value errors will be handled as errors on writing.

## Static Public Member Functions
template<typename ImagePixel>
static OFvariant< OFCondition, DPMParametricMapIOD > | create (const OFString &modality, const OFString &seriesNumber, const OFString &instanceNumber, const Uint16 rows, const Uint16 columns, const IODEnhGeneralEquipmentModule::EquipmentInfo &equipmentInfo, const ContentIdentificationMacro &contentIdentification, const OFString &imageFlavor, const OFString &derivedPixelContrast, const DPMTypes::ContentQualification &contentQualification)
| Create new Parametric Map object.
static OFvariant< OFCondition, DPMParametricMapIOD * > | loadFile (const OFString &filename)
| Load Parametric Map object from file.
static OFvariant< OFCondition, DPMParametricMapIOD * > | loadDataset (DcmDataset &dataset)
| Load Parametric Map object from dataset object.

## Protected Member Functions
virtual OFCondition | writeGeneric (DcmItem &dataset)
| Write current generic Parametric Map's attributes to DICOM dataset, i.e.
virtual OFCondition | readGeneric (DcmItem &dataset)
| Read Parametric Map's generic (not directly pixel-data related) attributes from DICOM dataset.
| DPMParametricMapIOD ()
| Constructor.
template<typename ImagePixel>
| DPMParametricMapIOD (OFin_place_type_t(ImagePixel))
| Constructor, anonymous parameter is the image pixel module to be used.
Protected Member Functions inherited from DPMParametricMapBase
| DPMParametricMapBase ()
| Constructor; not public since object should be create via factory method in derived class.
template<typename ImagePixel>
| DPMParametricMapBase (OFin_place_type_t(ImagePixel))
| Constructor; not public since object should be create via factory method in derived class.
virtual void | clearData ()
| Clear (removes) all attributes handled by the modules of this IOD.

## Static Protected Member Functions
static OFCondition | decompress (DcmDataset &dset)
| Decompress the given dataset if required.
Static Protected Member Functions inherited from DPMParametricMapBase
static OFCondition | loadFile (DcmFileFormat &dcmff, const OFString &filename, DcmDataset *&dset)
| Loads file.

## Private Member Functions
OFCondition | init (const OFString &modality, const OFString &seriesNumber, const OFString &instanceNumber, const IODEnhGeneralEquipmentModule::EquipmentInfo &equipmentInfo, const ContentIdentificationMacro &contentIdentification, const OFString &imageFlavor, const OFString &derivedPixelContrast, const DPMTypes::ContentQualification &contentQualification)
| Initialize new Parametric Map object except directly pixel-related data.

## Private Attributes
ContentIdentificationMacro | m_ContentIdentification
| Parametric Map Image Module's Content Identification.
OFVector< DcmIODTypes::Frame * > | m_Frames
| Binary frame data.

## Additional Inherited Members
Protected Attributes inherited from DPMParametricMapBase
FGInterface | m_FGInterface
| Multi-frame Functional Groups high level interface.
DPMParametricMapSeriesModule | m_DPMParametricMapSeriesModule
| Parametric Map Series Module.
IODEnhGeneralEquipmentModule | m_IODEnhGeneralEquipmentModule
| Enhanced General Equipment Module.
DPMParametricMapImageModule | m_DPMParametricMapImageModule
| Parametric Map Image Module.
IODMultiFrameFGModule | m_IODMultiFrameFGModule
| Multi-frame Functional Groups Module.
IODMultiframeDimensionModule | m_IODMultiframeDimensionModule
| Multi-frame Dimension Module.
IODAcquisitionContextModule | m_IODAcquisitionContextModule
| Acquisition Context Module.
IODCommonInstanceReferenceModule | m_IODCommonInstanceReferenceModule
| Common Instance Reference Module.

## Detailed Description

Class for managing the Parametric Map IOD attributes.

## Class Documentation

## ◆ DPMParametricMapIOD::GetPixelDataVisitor

class DPMParametricMapIOD::GetPixelDataVisitor

template<typename PixelType>
class DPMParametricMapIOD::GetPixelDataVisitor< PixelType >

## Member Function Documentation

## ◆ addForAllFrames()

virtual OFCondition DPMParametricMapIOD::addForAllFrames | ( | const FGBase & | group | ) |
| virtual

Add a functional group for all frames.

Parameters

  group | The group to be added as shared functional group

Returns
  EC_Normal if adding was successful, error otherwise

## ◆ check()

virtual OFBool DPMParametricMapIOD::check | ( |  | ) |
| virtual

Perform some basic checking.

This method is also invoked when writing the object to a DICOM dataset or file.

Returns
  OFTrue, if no errors were found, OFFalse otherwise.

Reimplemented from DPMParametricMapBase.

## ◆ create()

template<typename ImagePixel>

static OFvariant< OFCondition, DPMParametricMapIOD > DPMParametricMapIOD::create | ( | const OFString & | modality,
|  | const OFString & | seriesNumber,
|  | const OFString & | instanceNumber,
|  | const Uint16 | rows,
|  | const Uint16 | columns,
|  | const IODEnhGeneralEquipmentModule::EquipmentInfo & | equipmentInfo,
|  | const ContentIdentificationMacro & | contentIdentification,
|  | const OFString & | imageFlavor,
|  | const OFString & | derivedPixelContrast,
|  | const DPMTypes::ContentQualification & | contentQualification )
| static

Create new Parametric Map object.

Takes the minimum of required parameters. Afterwards, additional setters() can be used to set optional data. Frames and their related per-frame functional groups should be added using addFrame(). Shared functional groups should be added using addForAllFrames().

Parameters

  modality | The modality of this Parametric Map (series level attribute). A list of Defined Terms can be found in the standard. Very often "MR" is the right choice. Only if a mix of different modalities has been use for creation "OT" should be used.
  seriesNumber | A number identifying this series. If importHierarchy() is called later in order to put this Parametric Map into an existing Series, the Series Number will be taken over from the existing series instead.
  instanceNumber | A number identifying this image
  rows | The number of rows of all frames of the Parametric Map
  columns | The number of columns of all frames of the Parametric Map
  equipmentInfo | Information about the equipment creating thing Parametric Map
  contentIdentification | General information about this content
  imageFlavor | 3rd value of attribute Image Type. See standard for list of applicable Defined Terms.
  derivedPixelContrast | 4th value of attribute Image Type. See standard for list of applicable Defined Terms.
  contentQualification | Either one of CQ_PRODUCT, CQ_RESEARCH, CQ_SERVICE

Returns
  Variant, either OFCondition with error code in case of error, Parametric Map object in case of success

## ◆ decompress()

static OFCondition DPMParametricMapIOD::decompress | ( | DcmDataset & | dset | ) |
| staticprotected

Decompress the given dataset if required.

Only RLE compression is accepted and decompressed by this tool. A warning is printed if the dataset has been compressed before with another compression scheme and is handed into this method in uncompressed format. Handing in any other compression but RLE will lead to an error.

Parameters

  dset | The dataset to be decompressed

Returns
  EC_Normal if decompression worked (or dataset is already in uncompressed format) IOD_EC_CannotDecompress otherwise

## ◆ getColumns()

virtual OFCondition DPMParametricMapIOD::getColumns | ( | Uint16 & | cols | ) |
| virtual

Get number of cols.

Parameters

  cols | The number of columns (output)

Returns
  EC_Normal if getting was successful, error otherwise

## ◆ getContentQualification()

virtual DPMTypes::ContentQualification DPMParametricMapIOD::getContentQualification | ( |  | ) |
| virtual

Get Content Qualification.

Returns
  Returns either one of CQ_PRODUCT, CQ_RESEARCH, CQ_SERVICE or CQ_UNKNOWN

## ◆ getFrames()

FramesType DPMParametricMapIOD::getFrames | ( |  | ) |

Get access to frame data.

Returns
  Class managing the frame data

## ◆ getNumberOfFrames()

size_t DPMParametricMapIOD::getNumberOfFrames | ( |  | ) | const

Get number of frames, based on the number of items in the shared functional functional groups sequence (i.e. the attribute Number of Frames) is not trusted after reading.

Returns
  The number of frames handled by this object

## ◆ getRecognizableVisualFeatures()

virtual DPMTypes::RecognizableVisibleFeatures DPMParametricMapIOD::getRecognizableVisualFeatures | ( |  | ) |
| virtual

Get Recognizable Visual Features.

Returns
  Returns related YES or NO data type

## ◆ getRows()

virtual OFCondition DPMParametricMapIOD::getRows | ( | Uint16 & | rows | ) |
| virtual

Get number of rows.

Parameters

  rows | The number of rows (output)

Returns
  EC_Normal if getting was successful, error otherwise

## ◆ init()

OFCondition DPMParametricMapIOD::init | ( | const OFString & | modality,
|  | const OFString & | seriesNumber,
|  | const OFString & | instanceNumber,
|  | const IODEnhGeneralEquipmentModule::EquipmentInfo & | equipmentInfo,
|  | const ContentIdentificationMacro & | contentIdentification,
|  | const OFString & | imageFlavor,
|  | const OFString & | derivedPixelContrast,
|  | const DPMTypes::ContentQualification & | contentQualification )
| private

Initialize new Parametric Map object except directly pixel-related data.

Parameters

  modality | The modality of this Parametric Map (series level attribute). A list of Defined Terms can be found in the standard. Very often "MR" is the right choice. Only if a mix of different modalities has been use for creation "OT" should be used.
  seriesNumber | A number identifying this series. If importHierarchy() is called later in order to put this Parametric Map into an existing Series, the Series Number will be taken over from the existing series instead.
  instanceNumber | A number identifying this image
  equipmentInfo | Information about the equipment creating thing Parametric Map
  contentIdentification | General information about this content
  imageFlavor | 3rd value of attribute Image Type. See standard for list of applicable Defined Terms.
  derivedPixelContrast | 4th value of attribute Image Type. See standard for list of applicable Defined Terms.
  contentQualification | Either one of CQ_PRODUCT, CQ_RESEARCH, CQ_SERVICE

Returns
  EC_Normal in case of success, error otherwise

## ◆ loadDataset()

static OFvariant< OFCondition, DPMParametricMapIOD * > DPMParametricMapIOD::loadDataset | ( | DcmDataset & | dataset | ) |
| static

Load Parametric Map object from dataset object.

Parameters

  dataset | The dataset to read from

Returns
  Variant, either the resulting Parametric Map object in case of success, an OFCondition error code otherwise

## ◆ loadFile()

static OFvariant< OFCondition, DPMParametricMapIOD * > DPMParametricMapIOD::loadFile | ( | const OFString & | filename | ) |
| static

Load Parametric Map object from file.

Parameters

  filename | The file to read from

Returns
  Variant, either the resulting Parametric Map object in case of success, an OFCondition error code otherwise

## ◆ read()

virtual OFCondition DPMParametricMapIOD::read | ( | DcmItem & | dataset | ) |
| virtual

Read Parametric Map attributes (all those handled by this class) from given item.

Reads attributes from base class DcmIODCommon before. The current content is deleted even if the reading process fails. If the log stream is set and valid the reason for any error might be obtained from the error/warning output.

Parameters

  dataset | Reference to DICOM dataset from which the document should be read

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DPMParametricMapBase.

## ◆ readGeneric()

virtual OFCondition DPMParametricMapIOD::readGeneric | ( | DcmItem & | dataset | ) |
| protectedvirtual

Read Parametric Map's generic (not directly pixel-data related) attributes from DICOM dataset.

Parameters

  dataset | Reference to DICOM dataset to read from.

Returns
  EC_Normal if successful, an error code otherwise

## ◆ setRecognizableVisualFeatures()

virtual OFCondition DPMParametricMapIOD::setRecognizableVisualFeatures | ( | const DPMTypes::RecognizableVisibleFeatures | yesOrNo | ) |
| virtual

Indicates whether or not the image contains sufficiently recognizable visual features to allow the image or a reconstruction from a set of images to identify the patient.

Parameters

  yesOrNo | Must be related "YES" or "NO" types

Returns
  EC_Normal if setting was successful, error otherwise

## ◆ write()

virtual OFCondition DPMParametricMapIOD::write | ( | DcmItem & | dataset | ) |
| virtual

Write current Parametric Map's attributes to DICOM dataset.

Parameters

  dataset | Reference to DICOM dataset to which the current document should be written. The dataset is not cleared before writing to it!

Returns
  EC_Normal if successful, an error code otherwise

Reimplemented from DPMParametricMapBase.

## ◆ writeGeneric()

virtual OFCondition DPMParametricMapIOD::writeGeneric | ( | DcmItem & | dataset | ) |
| protectedvirtual

Write current generic Parametric Map's attributes to DICOM dataset, i.e.

those that are not directly pixel-related

Parameters

  dataset | Reference to DICOM dataset to which the current document should be written. The dataset is not cleared before writing to it.

Returns
  EC_Normal if successful, an error code otherwise

The documentation for this class was generated from the following file:

- dcmpmap/include/dcmtk/dcmpmap/dpmparametricmapiod.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2